config/routes.rb
Rails.application.routes.draw do

  mount ActionCable.server => '/cable'

  devise_for :users, controllers: {sessions: "sessions"}

  root to: "instapaper#index"

  get "instapaper/export" => 'instapaper#export', as: "export"
  post "instapaper/definitely_export" => 'instapaper#definitely_export', as: "definitely_export"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/downloadable_url.rb
# == Schema Information
#
# Table name: downloadable_urls
#
#  id          :integer          not null, primary key
#  dropbox_url :string           not null
#  user_id     :integer
#  created_at  :datetime
#  updated_at  :datetime
#

class DownloadableUrl < ActiveRecord::Base
	belongs_to :user

	validates :dropbox_url, presence: true

	scope :expired, -> { where(["created_at < ?", 4.hours.ago]) }
end

app/models/user.rb
# == Schema Information
#
# Table name: users
#
#  id                      :integer          not null, primary key
#  email                   :string           default(""), not null
#  encrypted_password      :string           default(""), not null
#  instapaper_token        :string           default(""), not null
#  instapaper_token_secret :string           default(""), not null
#  remember_created_at     :datetime
#  sign_in_count           :integer          default(0), not null
#  current_sign_in_at      :datetime
#  last_sign_in_at         :datetime
#  current_sign_in_ip      :inet
#  last_sign_in_ip         :inet
#  created_at              :datetime
#  updated_at              :datetime
#

class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable#, :registerable, :recoverable, :rememberable, :trackable, :validatable

  has_many :downloadable_urls
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception

  skip_before_action :verify_authenticity_token, :if => Proc.new { |c| c.request.format == 'application/json' }

  respond_to :html, :js, :json

  before_action :authenticate_user!
end

app/controllers/instapaper_controller.rb
class InstapaperController < ApplicationController

  before_action :init_instapaper_client
  after_action :request_instapaper_folders, only: :index

  def index
    respond_to do |format|
      format.html
      format.js
    end
  end

  def export
    get_folder_ids

    @errors = {}
    @errors[:messages] = []

    if @folder_ids.nil? or @folder_ids.empty?
      @errors[:messages] << "You have to select at least one folder"
    else
      folders = @client.folders.map {|folder| {folder_id: folder.folder_id, folder_title: folder.display_title}}.push({folder_id: 0, folder_title: "Root"})
      @selected_folders = folders.select {|h| @folder_ids.include?(h[:folder_id])}
    end

    if @errors[:messages].empty?
      respond_to do |format|
        format.js
      end
    else
      respond_to do |format|
        format.js { render status: 422 }
      end
    end
  end

  def definitely_export
    get_folder_ids

    ArticleJob.perform_later(@folder_ids, current_user.id)
    respond_to do |format|
      format.js
    end
  end

private

  def init_instapaper_client
    @client ||= Instapaper::Client.new do |client|
      client.consumer_key = ENV['INSTAPAPER_KEY']
      client.consumer_secret = ENV['INSTAPAPER_SECRET']
      client.oauth_token = current_user.instapaper_token
      client.oauth_token_secret = current_user.instapaper_token_secret
    end
  end

  def get_folder_ids
    if params[:folder_ids].present?
      @folder_ids ||= params[:folder_ids].map! {|id| id.to_i}
    else
      @folder_ids = []
    end
  end

  def request_instapaper_folders
    FoldersJob.set(wait: 1.second).perform_later(current_user.id)
  end

end

app/controllers/sessions_controller.rb
class SessionsController < Devise::SessionsController

  def new
    super
  end

  def create

    build_resource(sign_in_params)

    client = Instapaper::Client.new do |client|
      client.consumer_key = ENV['INSTAPAPER_KEY']
      client.consumer_secret = ENV['INSTAPAPER_SECRET']
    end

    begin
      token = client.access_token(sign_in_params["email"], sign_in_params["password"])
      client.oauth_token = token.oauth_token
      client.oauth_token_secret = token.oauth_token_secret
      client.verify_credentials

      existing_resource = warden.authenticate(auth_options)

      if existing_resource.present?
        self.resource = existing_resource
        resource.instapaper_token = token.oauth_token
        resource.instapaper_token_secret = token.oauth_token_secret
        resource.save
        set_flash_message!(:notice, :signed_in)
        sign_in(resource_name, resource)
        yield resource if block_given?
        respond_with resource, location: after_sign_in_path_for(resource)
      else
        resource.instapaper_token = token.oauth_token
        resource.instapaper_token_secret = token.oauth_token_secret
        resource.save
        yield resource if block_given?
        if resource.persisted?
          set_flash_message!(:notice, :signed_in)
          sign_in(resource_name, resource)
          respond_with resource, location: after_sign_in_path_for(resource)
        else
          clean_up_passwords resource
          set_minimum_password_length
          respond_with resource
        end
      end
    rescue Instapaper::Error::ClientError
      respond_with resource, status: :unauthorized, location: after_sign_in_path_for(resource)
    end
  end

  private

    def build_resource(hash=nil)
      self.resource = resource_class.new(hash || {})
    end

end

app/helpers/application_helper.rb
module ApplicationHelper
end

#### Detect best time zone to run the app
# zones = {cet: 0, pst: -9, est: -6, gmt: -2}

# zones.each do |key, value|
#   hours = cet.map do |i|
#     shift = i+value
#     shift < 0 ? 12+shift : shift
#   end
#   p hours
# end

# cet = [12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]
# pst = [3, 4, 5, 6, 7, 8, 9, 10, 11, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 0, 1, 2]
# est = [6, 7, 8, 9, 10, 11, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 0, 1, 2, 3, 4, 5]
# gmt = [10, 11, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9]

# hyp_cet_usage = [0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
# hyp_pst_usage = [1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
# hyp_est_usage = [1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
# hyp_gmt_usage = [1, 1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]

# hyp_usage = [1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]

app/views/instapaper/_export.html.erb
<h4 class="mdl-dialog__title">Esporta articoli</h4>
  <%= form_tag(definitely_export_path, method: "post", remote: true, html: { style: "display:inline;" }) do %>
    <div class="mdl-dialog__content">
      <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">
        Vuoi esportare tutti gli articoli delle cartelle
        <% @selected_folders.each_with_index do |folder, index|%>
          <em><%= "#{folder[:folder_title]}" %><% if index < (@folder_ids.length - 1) %>,<% end %></em>
        <% end %>?
      </div>
    </div>
    <% @folder_ids.each do |id| %>
      <%= hidden_field_tag "folder_ids[]", id %>
    <% end %>
  <div class="mdl-dialog__actions">
    <%= submit_tag "Sì", class: "mdl-button" %>
    <button type="button" class="mdl-button close">No</button>
  </div>
<% end %>

<script>
  var dialog = $("#folders-modal");
  dialog.find('.close').on('click', function() {
    dialog.dialog("close");
  });
</script>

app/views/instapaper/_index.html.erb
<p><em>Select one or more folders that contains the articles you want to export. Be aware that the max articles per folder is 500.</em></p>

<%= form_tag export_path, :method => :get, :remote => true do %>

  <div id="cable-content">
    <p style="text-align: center;"><strong>Streaming folders from Instapaper...</strong></p>
    <div id="p2" class="mdl-progress mdl-js-progress mdl-progress__indeterminate"></div>
    <br>
    <br>
  </div>

  <%= button_tag(type: "submit", class: "mdl-button mdl-js-button mdl-button--fab mdl-js-ripple-effect mdl-button--colored", style: "position: fixed; bottom: 30px; right: 30px;") do %>
      <i class="material-icons">backup</i>
  <% end %>
<% end %>

<div style="text-align: center;padding-top: 25px;">
  <form action="https://www.paypal.com/cgi-bin/webscr" method="post" target="_top">
    <input type="hidden" name="cmd" value="_s-xclick">
    <input type="hidden" name="hosted_button_id" value="ATHSA5YXG9LWY">
    <input type="image" src="https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online!">
    <img alt="" border="0" src="https://www.paypalobjects.com/it_IT/i/scr/pixel.gif" width="1" height="1">
  </form>
</div>

app/views/instapaper/_index_async.html.erb
<table class="mdl-data-table mdl-shadow--2dp" id="folders-list">
  <thead>
    <tr>
      <th></th>
      <th class="mdl-data-table__cell--non-numeric">Folder name</th>
      <th>Contained bookmarks</th>
    </tr>
  </thead>
  <tbody>
    <% data.each do |content| %>
      <tr>
        <td>
          <%= label_tag "folder_ids_#{content[:folder_id]}", '', class: "mdl-checkbox mdl-js-checkbox mdl-js-ripple-effect mdl-data-table__select" do %>
            <%= check_box_tag "folder_ids[]", content[:folder_id], false, :id => "folder_ids_#{content[:folder_id]}", class: "mdl-checkbox__input" %>
          <% end %>
        </td>
        <td class="mdl-data-table__cell--non-numeric"><%= content[:folder_title] %></td>
        <td><%= content[:bookmarks_count] %></td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/instapaper/definitely_export.js.erb
var dialog = $("#folders-modal");

var table = document.querySelector('table');
var boxes = table.querySelectorAll('tbody .mdl-data-table__select');
for (var i = 0, length = boxes.length; i < length; i++) {
	if (boxes[i].MaterialCheckbox === undefined) {
		boxes[i].children[0].checked = false;
	} else {
	  boxes[i].MaterialCheckbox.uncheck();
	}
};

dialog.dialog("close");

var snackbarContainer = document.querySelector('#demo-snackbar-example');
var data = {
	message: "Your data is going to be exported. You'll receive an email with a download link in 10 minutes.",
	timeout: 10000
};
snackbarContainer.MaterialSnackbar.showSnackbar(data);

amplitude.getInstance().logEvent('SUBMIT_ARTICLES_EXPORT');

app/views/instapaper/export.js.erb
<% if @errors[:messages].any? %>
	var snackbarContainer = document.querySelector('#demo-snackbar-example');
	var data = {
		message: "<%= j @errors[:messages].join('; ') %>",
		timeout: 5000
	};
	snackbarContainer.MaterialSnackbar.showSnackbar(data);
<% else %>
	$("#folders-modal").html("<%= escape_javascript(render 'export') %>");

	$("#folders-modal").dialog({
		dialogClass: "no-close",
		resizable: false,
		height: "auto",
		width: 400,
		modal: true,
		fluid: true,
		width: "auto",
		autoOpen: false,
		create: function(event, ui) {
			$(this).css("maxWidth", "300px");
		}
	});

	$("#folders-modal").dialog("open");

	amplitude.getInstance().logEvent('SHOW_EXPORT_MODAL');
<% end %>

app/views/instapaper/index.html.erb
<style>
.demo-list-action {
  width: 400;
}
.material-icons.red { color: #F44235; }
.material-icons.brown { color: #795548; }
.material-icons.yellow { color: #f9a825; }
.material-icons.md-18 { font-size: 18px; }
.material-icons.md-24 { font-size: 24px; }
.material-icons.md-36 { font-size: 36px; }
.material-icons.md-48 { font-size: 48px; }

.margin-left-20 { margin-left: 20px; }
.margin-top-10 { margin-top: 10px; }
</style>

<div class="mdl-grid">
  <div class="mdl-cell mdl-cell--4-col mdl-cell--2-col-tablet mdl-cell--0-col-phone">
  </div>

	<div class="mdl-cell mdl-cell--4-col mdl-cell--4-col-tablet mdl-cell--6-col-phone">
		<div class="demo-list-action mdl-list" style="display: block; width: 100%; table-layout: fixed;">
			<%= render "index" %>
		</div>
	</div>

  <div class="mdl-cell mdl-cell--4-col mdl-cell--2-col-tablet mdl-cell--0-col-phone"></div>
</div>

<script type="text/javascript">

$( document ).ready(function() {

  $(document).ajaxStart(function(){
    $.blockUI({baseZ: 9999, message: '<h4>Loading...</h4>', css: {
            border: 'none',
            padding: '15px',
            backgroundColor: '#000',
            '-webkit-border-radius': '10px',
            '-moz-border-radius': '10px',
            opacity: .5,
            color: '#fff'
        } });
  });

  $(document).ajaxStop(function(){
    $.unblockUI()
  });

  <% if user_signed_in? %>
    amplitude.getInstance().setUserId(<%= current_user.id %>);
    var identify = new amplitude.Identify().set('email', "<%= current_user.email %>");
    amplitude.getInstance().identify(identify);
    amplitude.getInstance().logEvent('PAGEVIEW');
  <% end %>

});

</script>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">

  <title>Convert Instapaper articles in PDFs | InstaPDFpaper</title>
  <meta name="description" content="Seamlessly download in PDF format all your Instapaper articles">
  <meta name="keywords" content="pdf,instapaper,instapdf">
  <meta name="robots" content="index,follow">
  <%= stylesheet_link_tag "https://fonts.googleapis.com/icon?family=Material+Icons" %>
  <link rel="stylesheet" href="https://code.getmdl.io/1.3.0/material.cyan-blue.min.css" />

  <%#= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => 'reload' %>
  <%#= javascript_include_tag 'application', 'data-turbolinks-track' => 'reload' %>

  <%= stylesheet_link_tag    'application', media: 'all' %>
  <%= javascript_include_tag 'application' %>

  <%= action_cable_meta_tag %>

  <script defer src="https://code.getmdl.io/1.2.1/material.min.js"></script>

  <script type="text/javascript">
    (function(e,t){var n=e.amplitude||{_q:[],_iq:{}};var r=t.createElement("script");r.type="text/javascript";
    r.async=true;r.src="https://d24n15hnbwhuhn.cloudfront.net/libs/amplitude-3.4.1-min.gz.js";
    r.onload=function(){if(e.amplitude.runQueuedFunctions){e.amplitude.runQueuedFunctions();
    }else{console.log("[Amplitude] Error: could not load SDK")}};var i=t.getElementsByTagName("script")[0];
    i.parentNode.insertBefore(r,i);function o(e,t){e.prototype[t]=function(){this._q.push([t].concat(Array.prototype.slice.call(arguments,0)));
    return this}}var s=function(){this._q=[];return this};var a=["add","append","clearAll","prepend","set","setOnce","unset"];
    for(var u=0;u<a.length;u++){o(s,a[u])}n.Identify=s;var c=function(){this._q=[];return this;
    };var l=["setProductId","setQuantity","setPrice","setRevenueType","setEventProperties"];
    for(var p=0;p<l.length;p++){o(c,l[p])}n.Revenue=c;var d=["init","logEvent","logRevenue","setUserId","setUserProperties","setOptOut","setVersionName","setDomain","setDeviceId","setGlobalUserProperties","identify","clearUserProperties","setGroup","logRevenueV2","regenerateDeviceId","logEventWithTimestamp","logEventWithGroups"];
    function v(e){function t(t){e[t]=function(){e._q.push([t].concat(Array.prototype.slice.call(arguments,0)));
    }}for(var n=0;n<d.length;n++){t(d[n])}}v(n);n.getInstance=function(e){e=(!e||e.length===0?"$default_instance":e).toLowerCase();
    if(!n._iq.hasOwnProperty(e)){n._iq[e]={_q:[]};v(n._iq[e])}return n._iq[e]};e.amplitude=n;
    })(window,document);

    amplitude.getInstance().init("<%= Rails.env.production? ? "edf0c294771b6013ebde4a2cb74474ec" : "121999ff575423cd53be243936689b33" %>");
  </script>

  <style type="text/css">
    input:focus,
    select:focus,
    textarea:focus,
    a:focus,
    button:focus {
      outline: none;
    }

    .force-lowercase {
      text-transform: capitalize; !important;
    }
  </style>

  <%= csrf_meta_tags %>
</head>
<body>

<div class="mdl-layout mdl-js-layout mdl-layout--fixed-header">
  <% if user_signed_in? %>
  <header class="mdl-layout__header" style="min-height: 50px;">
    <div class="mdl-layout__header-row mdl-layout--small-screen-only" style="height: 50px;">
      <span class="mdl-layout-title" style="font-size: 12px;">
        <img src="https://staticinstapaper.s3.amazonaws.com/img/logo.png">
        <%= current_user.email %>
      </span>
      <nav class="mdl-navigation">
        <% if user_signed_in? %>
          <%= link_to('Logout', destroy_user_session_path, :method => :delete, :class => "mdl-button mdl-js-button force-lowercase") %>
        <% else %>
          <%= link_to('Login', new_user_session_path, :class => "mdl-button mdl-js-button force-lowercase") %>
        <% end %>
      </nav>
    </div>
    <div class="mdl-layout__header-row mdl-layout--large-screen-only" style="height: 50px;">
      <!-- Title -->
      <span class="mdl-layout-title" style="font-size: 14px;">
        <img src="https://staticinstapaper.s3.amazonaws.com/img/logo.png">
        <%= current_user.email %>
      </span>
      <!-- Add spacer, to align navigation to the right -->
      <div class="mdl-layout-spacer"></div>
      <!-- Navigation. We hide it in small screens. -->
      <nav class="mdl-navigation">
      	<% if user_signed_in? %>
				  <%= link_to('Logout', destroy_user_session_path, :method => :delete, :class => "mdl-button mdl-js-button mdl-layout--large-screen-only") %>
				<% else %>
				  <%= link_to('Login', new_user_session_path, :class => "mdl-button mdl-js-button mdl-layout--large-screen-only") %>
				<% end %>
        <a class="mdl-navigation__link" href=""></a>
      </nav>
    </div>
  </header>
  <% end %>
  <main class="mdl-layout__content">
    <div class="page-content">
    	<%= yield %>
    </div>
  </main>
</div>

<div id="demo-snackbar-example" class="mdl-js-snackbar mdl-snackbar">
  <div class="mdl-snackbar__text"></div>
  <button class="mdl-snackbar__action" type="button"></button>
</div>

</body>

<div id="folders-modal"></div>
<div id="customer-modal"></div>

</html>